`timescale 1 ns / 1 ps

module PCAddressComputer( PCIn, Inst, zero, RS, Jump,JR,Branch,PCOut );
	input wire [31:0] PCIn; // Address of Next Instruction (PC + 4)
	input wire [31:0] Inst; // Instruction
	input wire [31:0] RS;   // value of register specified by RS field of Inst
	input wire zero;		// set if ALUOut == 0
	input wire Jump;		// set if Inst indicates a jump operation
	input wire JR;			// set if Inst is JR or JALR
	input wire Branch;		// set if Inst is BEQ,BNE,BLEZ,BGTZ
	output wire [31:0] PCOut; 
	
	// Relevant opcodes
	
	parameter BEQ = 2'b00;	  // Branch if Equal
	parameter BGTZ = 2'b11;	  // Branch if Greater Than Zero
	parameter BLEZ = 2'b10;	  // Branch if Less than or Equal to Zero
	parameter BNE = 2'b01;	  // Branch if Not Equal 
	
	wire [31:0] BranchAddress; // target if its a branch
	wire [31:0] JumpAddress;   // target if its a jump
		
	// Your Code Goes Here //
	
	
	
endmodule

							