//--------------------------------------------------------------------------------------------------
//
// Title       : Clock System
// Design      : single
// Author      : cse
// Company     : uw
//
//-------------------------------------------------------------------------------------------------
//
// File        : Z:\pipelined\compile\ClockSystem.v
// Generated   : Tue May  2 15:22:30 2006
// From        : Z:\pipelined\src\ClockSystem.bde
// By          : Bde2Verilog ver. 2.01
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------

`ifdef _VCP
`else
`define library
`define synthesis
`endif




// ---------- Design Unit Header ---------- //
`timescale 1ps / 1ps

module ClockDivider (SYSTEM_CLOCK, CLK, DCM_RESET) /* synthesis syn_black_box */ ;
	input SYSTEM_CLOCK;	
	input DCM_RESET;
	output CLK;		
	
	parameter CLKFX_Mult = 1;
	parameter CLKFX_Div = 2;
	
	// synopsys translate_off
	
	wire FeedbackLoop;
	wire GND = 0;

	`library("dcm","virtex2p")

	DCM
	#(					  
		.CLKFX_DIVIDE(CLKFX_Div),
		.CLKFX_MULTIPLY(CLKFX_Mult)
	)
	dcm
	(
		.CLK0(FeedbackLoop),
		.CLKFB(FeedbackLoop),
		.CLKFX(CLK),
		.CLKIN(SYSTEM_CLOCK),
		.DSSEN(GND),
		.PSCLK(GND),
		.PSEN(GND),
		.PSINCDEC(GND),
		.RST(DCM_RESET)
	)/*synthesis xc_props="CLKIN_PERIOD=10"*/; 
	
	// synopsys translate_on

endmodule

// ---------- Synthesis black box modules ---------- //
// synopsys translate_off
// synthesis translate_on
`ifdef synthesis
// synthesis translate_off
// synopsys translate_on

// synopsys translate_off
// synthesis translate_on
`ifdef INC_BUF_V
`else
`define INC_BUF_V 1
// synthesis translate_off
// synopsys translate_on
module BUF ( I ,O ) /* synthesis syn_black_box */ ;
	input I ;
	output O ;
endmodule
// synopsys translate_off
// synthesis translate_on
`endif
// synthesis translate_off
// synopsys translate_on

// synopsys translate_off
// synthesis translate_on
`ifdef INC_STARTBUF_VIRTEX2_V
`else
`define INC_STARTBUF_VIRTEX2_V 1
// synthesis translate_off
// synopsys translate_on
module STARTBUF_VIRTEX2 ( CLKIN ,GSRIN ,GTSIN ,GSROUT ,GTSOUT ) /* synthesis syn_black_box */ ; 
	input CLKIN ;
	input GSRIN ;
	input GTSIN ;
	output GSROUT ;
	output GTSOUT ;
endmodule
// synopsys translate_off
// synthesis translate_on
`endif
// synthesis translate_off
// synopsys translate_on

// synopsys translate_off
// synthesis translate_on
`endif
// synthesis translate_off
// synopsys translate_on


module ClockSystem (SYSTEM_CLOCK,Hard_Reset_Switch,Soft_Reset_Switch,CLK,Reset,SerialClock,VGAClock) /* synthesis syn_black_box */ ;

// ------------ Port declarations --------- //
input SYSTEM_CLOCK;
wire SYSTEM_CLOCK;
input Hard_Reset_Switch;
wire Hard_Reset_Switch;
input Soft_Reset_Switch;
wire Soft_Reset_Switch;
output CLK;
wire CLK;
output Reset;
wire Reset;
output SerialClock;
wire SerialClock;
output VGAClock;
wire VGAClock; 

// synopsys translate_off

// ----------- Signal declarations -------- //
wire GSR;
supply0 GND;

// -------- Component instantiations -------//

ClockDivider
#(
	.CLKFX_Div(4),
	.CLKFX_Mult(2))
ClockDiv
(
	.CLK(CLK),
	.DCM_RESET(GSR),
	.SYSTEM_CLOCK(SYSTEM_CLOCK)
);



ClockDivider
#(
	.CLKFX_Div(4),
	.CLKFX_Mult(2))
SerialClockDiv
(
	.CLK(SerialClock),
	.DCM_RESET(GSR),
	.SYSTEM_CLOCK(SYSTEM_CLOCK)
);





`library("U1","virtex2p")
`library("U8","virtex2p")

BUF U1
(
	.I(~Soft_Reset_Switch),
	.O(Reset)
);



STARTBUF_VIRTEX2 U8
(
	.GSRIN(~Hard_Reset_Switch),
	.GSROUT(GSR),
	.GTSIN(GND),
	.CLKIN(GND)
);


ClockDivider
#(
	.CLKFX_Div(10),
	.CLKFX_Mult(4))
VGAClockDiv
(
	.CLK(VGAClock),
	.DCM_RESET(GSR),
	.SYSTEM_CLOCK(SYSTEM_CLOCK)
);


// synopsys translate_on
endmodule

